Skip site navigation (1)Skip section navigation (2)
Date:      Thu, 30 Jan 2014 11:35:19 +0000 (UTC)
From:      Peter Holm <pho@FreeBSD.org>
To:        src-committers@freebsd.org, svn-src-user@freebsd.org
Subject:   svn commit: r261289 - user/pho/stress2/misc
Message-ID:  <201401301135.s0UBZJM9011935@svn.freebsd.org>

next in thread | raw e-mail | index | archive | help
Author: pho
Date: Thu Jan 30 11:35:19 2014
New Revision: 261289
URL: http://svnweb.freebsd.org/changeset/base/261289

Log:
  Added a test scenario for swapoff(8).
  
  Sponsored by:	EMC / Isilon storage division

Added:
  user/pho/stress2/misc/stealer.sh   (contents, props changed)

Added: user/pho/stress2/misc/stealer.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ user/pho/stress2/misc/stealer.sh	Thu Jan 30 11:35:19 2014	(r261289)
@@ -0,0 +1,130 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2014 EMC Corp.
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+# Process stuck in objtrm wait state
+# http://people.freebsd.org/~pho/stress/log/stealer.txt
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+. ../default.cfg
+
+here=`pwd`
+cd /tmp
+sed '1,/^EOF/d' < $here/$0 > stealer.c
+cc -o stealer -Wall -Wextra stealer.c || exit 1
+rm -f stealer.c
+cd $here
+swapoff -a > /dev/null
+
+dd if=/dev/zero of=$diskimage bs=1m count=1k 2>&1 |
+    egrep -v 'records|transferred'
+mdconfig -l | grep -q md$mdstart &&  mdconfig -d -u $mdstart
+mdconfig -a -t vnode -f $diskimage -u $mdstart
+swapon /dev/md$mdstart
+
+hw=`sysctl hw.pagesize | sed 's/.*: //'`
+pages=`sysctl hw.usermem  | sed 's/.*: //'`
+pages=$((pages / hw))
+echo "`date '+%T'` Test with $pages pages."
+su $testuser -c "sh -c \"/tmp/stealer $pages\"" &
+sleep 30
+while ! swapoff /dev/md$mdstart 2>&1 |
+    grep -v "Cannot allocate memory"; do
+	sleep 2
+done
+wait
+
+swapon -a > /dev/null
+
+mdconfig -d -u $mdstart
+rm -rf /tmp/stealer $diskimage
+exit 0
+EOF
+#include <err.h>
+#include <signal.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <sys/wait.h>
+
+#define N 200
+
+void
+handler(int i __unused)
+{
+	_exit(0);
+}
+
+void
+stealer(int pages)
+{
+	char *c;
+	int i, page, size;
+
+	page = getpagesize();
+	size = pages * page;
+	if ((c = malloc(size)) == 0)
+		err(1, "malloc(%d pages)", pages);
+
+	signal(SIGALRM, handler);
+	alarm(3 * 60);
+	for (;;) {
+		i = 0;
+		while (i < size) {
+			c[i] = 0;
+			i += page;
+		}
+	}
+}
+
+int
+main(int argc __unused, char **argv)
+{
+	int i, j, n, pages, status;
+
+	pages = atoi(argv[1]);
+	n = pages / N;
+
+	j = 0;
+	for ( i = 0; i < N; i++, j++) {
+		if (fork() == 0)
+			stealer(n);
+		pages = pages - n;
+	}
+	if (pages > 0) {
+		j++;
+		if (fork() == 0)
+			stealer(pages);
+	}
+	while (j-- > 0)
+		if (wait(&status) == -1)
+			err(1, "wait()");
+	return (0);
+}



Want to link to this message? Use this URL: <https://mail-archive.FreeBSD.org/cgi/mid.cgi?201401301135.s0UBZJM9011935>